from .const import DOMAIN as DOMAIN
from .entity import LitterRobotConfigEntity as LitterRobotConfigEntity
from .hub import LitterRobotHub as LitterRobotHub
from homeassistant.components.switch import SwitchEntity as SwitchEntity
from homeassistant.config_entries import ConfigEntry as ConfigEntry
from homeassistant.core import HomeAssistant as HomeAssistant
from homeassistant.helpers.entity_platform import AddEntitiesCallback as AddEntitiesCallback
from typing import Any

class LitterRobotNightLightModeSwitch(LitterRobotConfigEntity, SwitchEntity):
    @property
    def is_on(self) -> Union[bool, None]: ...
    @property
    def icon(self) -> str: ...
    async def async_turn_on(self, **kwargs: Any) -> None: ...
    async def async_turn_off(self, **kwargs: Any) -> None: ...

class LitterRobotPanelLockoutSwitch(LitterRobotConfigEntity, SwitchEntity):
    @property
    def is_on(self) -> Union[bool, None]: ...
    @property
    def icon(self) -> str: ...
    async def async_turn_on(self, **kwargs: Any) -> None: ...
    async def async_turn_off(self, **kwargs: Any) -> None: ...

ROBOT_SWITCHES: list[tuple[type[Union[LitterRobotNightLightModeSwitch, LitterRobotPanelLockoutSwitch]], str]]

async def async_setup_entry(hass: HomeAssistant, entry: ConfigEntry, async_add_entities: AddEntitiesCallback) -> None: ...
